=== libr/main/Makefile ===
include ../config.mk

NAME=r_main

R2DEPS=r_core

OBJS+=main.o
OBJS+=ravc2.o
OBJS+=rax2.o
OBJS+=r2pm.o
OBJS+=rasm2.o
OBJS+=ragg2.o
OBJS+=rarun2.o
OBJS+=rabin2.o
OBJS+=rasign2.o
OBJS+=rafind2.o
OBJS+=r2agent.o
OBJS+=radiff2.o
OBJS+=radare2.o
OBJS+=rahash2.o

# See MAIN_LINK_ALL
include deps.mk

include ../rules.mk
