=== libr/search/Makefile ===
include ../config.mk

NAME=r_search

OBJS=search.o bytepat.o strings.o aes_find.o privkey.o
OBJS+=regexp.o keyword.o uds.o karp.o sm4_find.o tire.o

R2DEPS=r_util r_crypto

include ../rules.mk
