=== debian/changelog ===
radare2 (5.9.4+dfsg-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Alex Myczko <tar@debian.org>  Sat, 24 Aug 2024 11:12:35 +0200

radare2 (5.9.4+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Sat, 10 Aug 2024 19:36:51 +0000
