## radare2 5.9.8%2Bdfsg

=== shlr/Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 endif
 
 ifeq ($(CS_RELEASE),1)
-CS_VER=5.0.1
+CS_VER=5.0.3
 CS_TAR=https://codeload.github.com/capstone-engine/capstone/tar.gz/$(CS_VER)
 #CS_TAR=http://capstone-engine.org/download/$(CS_VER)/capstone-$(CS_VER).tgz
 CS_PATCHES=0
@@ -49,14 +49,14 @@
 CS_UPD=20201203
 # NOTE: when you update CS_TIP or CS_BRA, also update them in shlr/meson.build
 ifeq ($(USE_CSNEXT),1)
-CS_TIP=58528853111377ba2f8ecb781f8d3bdc595900ed
+CS_TIP=76242699291a998d27934442ab5b425e2d566a03
 CS_BRA=next
 else
 ifeq ($(USE_CS4),1)
 CS_TIP=0efa3cc530ea188c0e03c945ab884ee19dd16342
 CS_BRA=v4
 else
-CS_TIP=00b961a680c488081a165cc31e98699d45a0a515
+CS_TIP=8455b3c5a53b02e524494c7e72a3946a32518170
 CS_BRA=v5
 endif
 endif
@@ -366,19 +366,11 @@
 libr_shlr.${EXT_AR}:
 	rm -rf .libr
 	mkdir .libr
-ifeq ($(CC),emcc)
-	for LIB in ${SHLRS} ; do \
-		if [ -f "$${LIB}" ]; then emcc -emit-llvm -nostdlib -Wl,--whole-archive -o .libr/$$(basename $${LIB}.a).o $${LIB} ; fi ; \
-	done
-	${AR} rs $@ .libr/*.o
-	$(RANLIB) $@
-else
 	for LIB in ${SHLRS} ; do \
 		if [ -f "$${LIB}" ]; then ${PARTIALLD} -o .libr/$$(basename $${LIB}.a).o $${LIB} ; fi ; \
 	done
 	${AR} rs $@ .libr/*.o
 	$(RANLIB) $@
-endif
 
 .PHONY: spp
