=== libr/arch/p/arm/aarch64/Makefile ===
CC=clang
all:
	${CC} -I. -I ../../../arch/include *.c
