=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: radare2
 Section: devel
 Priority: optional
-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Andrej Shadura <andrewsh@debian.org>,
            Sebastian Reichel <sre@debian.org>,
            Alex Myczko <tar@debian.org>,
-Build-Depends: dpkg-dev, debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                libcapstone-dev,
                libgmp-dev,
                libmagic-dev,
